<ui:composition xmlns:g="http://www.ihe.net/gazelle"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        <h:form>
            <s:div id="globalDiv">
                <h1>#{messages['net.ihe.gazelle.xvre.ManageApplicationPreferences']}</h1>
                <s:div styleClass="panel panel-default" rendered="#{applicationManager.preference != null}">
                    <div class="panel-heading">#{messages['net.ihe.gazelle.xvre.NewApplicationPreference']}</div>
                    <div class="panel-body">
                        <s:decorate template="/layout/form/_edit.xhtml">
                            <ui:param name="id" value="nameInput"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.xvre.PreferenceName']}</ui:define>
                            <h:inputText value="#{applicationManager.preference.variable}" id="nameInput"
                                         styleClass="form-control"/>
                        </s:decorate>
                        <s:decorate template="/layout/form/_edit.xhtml">
                            <ui:param name="id" value="valueInput"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.xvre.Value']}</ui:define>
                            <h:inputText value="#{applicationManager.preference.value}" id="valueInput"
                                         styleClass="form-control"/>
                        </s:decorate>
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.xvre.Save']}"
                                           actionListener="#{applicationManager.savePreference(applicationManager.preference)}"
                                           render="globalDiv" styleClass="gzl-btn-green"/>
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.Cancel']}"
                                           actionListener="#{applicationManager.setPreference(null)}"
                                           render="globalDiv" styleClass="gzl-btn-orange"/>
                    </div>
                </s:div>
                <a4j:commandButton value="#{messages['net.ihe.gazelle.xvre.AddAPreference']}"
                                   actionListener="#{applicationManager.createNewPreference()}"
                                   rendered="#{applicationManager.preference == null}" render="globalDiv"
                                   styleClass="gzl-btn-green"/>
                <!--  http headers Section -->
                <a4j:commandButton action="#{applicationManager.resetHttpHeaders()}"
                                   value="#{messages['net.ihe.gazelle.xvre.SetDefaultHttpHeadersValues']}"
                                   render="globalDiv" execute="@this" styleClass="gzl-btn-blue"/>
                <a4j:commandButton action="#{applicationManager.updateHttpHeaders()}"
                                   value="#{messages['net.ihe.gazelle.xvre.UpdateHTTPSecurityPolicies']}"
                                   render="globalDiv" execute="@this" styleClass="gzl-btn-blue"/>
                <br/>
                <rich:dataTable value="#{applicationManager.getAllPreferences()}" var="pref">
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.xvre.PreferenceName']}</ui:define>
                        <rich:inplaceInput value="#{pref.variable}"
                                           showControls="true" inputWidth="100">
                            <a4j:ajax event="change"
                                      listener="#{applicationManager.savePreference(pref)}"
                                      render="globalDiv"/>
                        </rich:inplaceInput>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.xvre.PreferenceValue']}</ui:define>
                        <rich:inplaceInput value="#{pref.value}"
                                           defaultLabel="Click to set value"
                                           showControls="true" inputWidth="100">
                            <a4j:ajax event="change"
                                      listener="#{applicationManager.savePreference(pref)}"
                                      render="globalDiv"/>
                        </rich:inplaceInput>
                    </g:column>
                </rich:dataTable>
            </s:div>
        </h:form>
    </ui:define>
</ui:composition>
